# qubicj

QubicJ aims to provide Java infrastructure for interacting within the Qubic framework. It consists out of several modules.

* [qubicj-computor-api](./qubicj-computor-api/README.md) ... contains code for communicating with qubic nodes (computors).
* [qubicj-vanity-id](./qubicj-vanity-id/README.md) ... contains a tool for generating vanity IDs.
* [qubicj-shell](./qubicj-shell/README.md) ... console application for wallet operations and accessing qubic nodes.
* ... more to come ...

See readme files in submodules for detailed information. The application submodules are demos for how to use the qubicj computor api.

## Getting started

For compiling and running you need to have at least `Java 21` and `maven` (maven is optional, you can also use the `mvnw`
maven wrapper in the qubicj directory). Only Linux is supported, but it should be able to build and run on all operating 
systems that have Java available.

1. **IMPORTANT**: [Install shared library](./qubicj-computor-api/README.md#install-shared-library)
2. Build qubicj

If you only want to use the qubicj-computor-api in your own project then you do not need to build it but
simply need to include the dependency in your project. See submodule documentation.

### Build

You need to install the `qubic-parent` and `qubicj-computor-api` submodule locally for the other submodules to build. 
To do this, execute the following command in the outermost `qubicj` folder:

```shell
./mvnw clean install
```

This builds the parent and all modules and runs the tests.

## Support

For support contact me in the [qubic discord](https://discord.gg/ZCmwx5V9) => user: `o.mio` aka `mio`. Feel free to open issues for feature requests and bugs.

## Contributing

Contributions are welcome. If you contribute code you agree on licensing it under the projects license and guarantee that the code is your own and free
of copyright issues. You agree that the owner of this project can
use your code and is allowed to use it under another proprietary license as well (for dual licensing). If you contribute you
need to agree to these conditions. For example do that in a commit to this README file and state it in the commit message explicitly.

[//]: # ()
[//]: # (For people who want to make changes to your project, it's helpful to have some documentation on how to get started. Perhaps there is a script that they should run or some environment variables that they need to set. Make these steps explicit. These instructions could also be useful to your future self.)

[//]: # ()
[//]: # (You can also document commands to lint the code or run tests. These steps help to ensure high code quality and reduce the likelihood that the changes inadvertently break something. Having instructions for running tests is especially helpful if it requires external setup, such as starting a Selenium server for testing in a browser.)

[//]: # ()
[//]: # (## Authors and acknowledgment)

[//]: # (Show your appreciation to those who have contributed to the project.)


## License

This software (qubicj and all of its submodules) is licensed under the GNU Affero General Public License (AGPL).
See [LICENSE](COPYING) for details. If you have special needs contact me for dual licensing.

The logo is a modified version of the official bash logo. 
See [Logo Repository](https://github.com/odb/official-bash-logo) 
and [License](https://github.com/odb/official-bash-logo/blob/master/assets/LICENSE).