package at.qubic.api.crypto;

/**
 * Use it if no shared qubic crypto library is installed but the functionality
 * is not used by your code. Other implementations (QubicFourQ) will try to load the shared library
 * and fail.
 */
public class NoCrypto implements SchnorrQubic, FourQ {

    @Override
    public byte[] ecc_mul_fixed(byte[] in) {
        throw new UnsupportedOperationException("Operation not supported by this implementation. Use QubicFourQ instead.");
    }

    @Override
    public void ecc_mul_fixed(byte[] in, byte[] out) {
        throw new UnsupportedOperationException("Operation not supported by this implementation. Use QubicFourQ instead.");
    }

    @Override
    public byte[] sign(byte[] subSeed, byte[] publicKey, byte[] digest) {
        throw new UnsupportedOperationException("Operation not supported by this implementation. Use QubicFourQ instead.");
    }

    @Override
    public byte[] signWithNonceK(byte[] nonceK, byte[] publicKey, byte[] digest) {
        throw new UnsupportedOperationException("Operation not supported by this implementation. Use QubicFourQ instead.");
    }

    @Override
    public boolean verify(byte[] publicKey, byte[] messageDigest, byte[] signature) {
        throw new UnsupportedOperationException("Operation not supported by this implementation. Use QubicFourQ instead.");
    }

}
