package at.qubic.api.domain;

import lombok.Getter;
import lombok.extern.slf4j.Slf4j;

@Getter
@Slf4j
public enum MessageType {

    // see for examples define.h in qubic-cli
    EXCHANGE_PUBLIC_PEERS(0),
//    BROADCAST_COMPUTORS(2),
    BROADCAST_FUTURE_TICK_DATA(8),
    REQUEST_COMPUTORS(11),
    REQUEST_TICK_DATA(16),
    BROADCAST_TRANSACTION(24),
    REQUEST_CURRENT_TICK_INFO(27),
    RESPOND_CURRENT_TICK_INFO(28),
    REQUEST_TICK_TRANSACTIONS(29),
    REQUEST_ENTITY(31),
    RESPOND_ENTITY(32),
    END_RESPONSE(35),
//    REQUEST_ISSUED_ASSETS(36),
//    RESPOND_ISSUED_ASSETS(37),
    REQUEST_OWNED_ASSETS(38),
    RESPOND_OWNED_ASSETS(39),
    REQUEST_POSSESSED_ASSETS(40),
    RESPOND_POSSESSED_ASSETS(41),
    REQUEST_CONTRACT_FUNCTION(42),
    RESPOND_CONTRACT_FUNCTION(43),
    TRY_AGAIN(46),
    REQUEST_ASSETS(52),
    RESPOND_ASSETS(53),
    PROCESS_SPECIAL_COMMAND(255),
    UNKNOWN(Byte.MIN_VALUE);

    private final byte code;

    MessageType(int code) {
        this.code = (byte) code;
    }

    public static MessageType fromCode(byte code) {
        for (MessageType value : values()) {
            if (value.code == code) {
                return value;
            }
        }
        log.warn("Unknown message type code: [{}].", code);
        return UNKNOWN;
    }

}
