package at.qubic.api.domain;

import org.apache.commons.lang3.ArrayUtils;

import java.util.Objects;

public abstract class QubicRequest {

    public abstract MessageType getMessageType();

    protected abstract byte[] getMessagePayload();

    protected boolean isZeroDejaVu() {
        return false;
    }

    public QubicMessage toMessage() {
        byte[] payload = getMessagePayload();
        Objects.requireNonNull(payload);
        QubicHeader.QubicHeaderBuilder qubicHeader = QubicHeader.builder()
                .type(getMessageType())
                .size(QubicHeader.HEADER_LENGTH + ArrayUtils.getLength(payload));
        if (isZeroDejaVu()) {
            qubicHeader.dejavu(0);
        }
        return QubicMessage.builder()
                .header(qubicHeader.build())
                .payload(getMessagePayload())
                .build();
    }

}
