package at.qubic.api.domain;

import lombok.Getter;
import lombok.RequiredArgsConstructor;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Getter
@RequiredArgsConstructor
public abstract class RequestContractFunction extends QubicRequest {

    static final int SIZE = 8;

    private final int contractIndex;
    private final short inputType;

    @Override
    public MessageType getMessageType() {
        return MessageType.REQUEST_CONTRACT_FUNCTION; // 42
    }

    @Override
    public byte[] getMessagePayload() {
        byte[] input = toBytes();
        return ByteBuffer.allocate(SIZE + input.length)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putInt(contractIndex)
                .putShort(inputType)
                .putShort((short) input.length)
                .put(toBytes())
                .array();
    }

    protected abstract byte[] toBytes();

}

