package at.qubic.api.domain;

public interface TransactionExtraData {

    /**
     * The amount needed for the transaction. Depending on the extra data
     * different amounts might need to be set.
     * @return the amount that should be set to the transaction. Defaults to 1L.
     */
    default long getAmount() { return 1L; }

    /**
     * The input type that fits to the transaction extra data.
     * @return the input type of the transctions.
     */
    short getInputType();

    /**
     * Gets the transaction extra data in byte format. This bytes can be directly used
     * for the transaction extra data field.
     * @return the transaction extra data bytes.
     */
    byte[] toBytes();

}
