package at.qubic.api.domain.event.response;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@SuperBuilder
@Getter
@EqualsAndHashCode
@ToString
public class ContractInformationEvent {

    /*
        unsigned int _contractIndex;
        unsigned int _type;
        ... rest in sub classes
     */

    private final int contractIndex;
    private final int type;

    public static ContractInformationEvent fromBytes(byte[] bytes) {
        // buffer will have remaining bytes as the contract information message
        // will have additional information. See subclasses.
        ByteBuffer buffer = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
        return ContractInformationEvent.builder()
                .contractIndex(buffer.getInt())
                .type(buffer.getInt())
                .build();
    }

}
