package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.RequestContractFunction;
import at.qubic.api.domain.qearn.Qearn;
import lombok.Builder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
public class GetLockInfoForEpoch extends RequestContractFunction {

    static final short INPUT_SIZE = 4;
    private final int epoch; // uint32 - 4 byte

    private GetLockInfoForEpoch(int epoch) {
        super(Qearn.CONTRACT_INDEX, Qearn.Function.QEARN_GET_LOCK_INFO_PER_EPOCH.getCode());
        this.epoch = epoch;
    }

    @Override
    protected byte[] toBytes() {
        return ByteBuffer.allocate(INPUT_SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putInt(epoch)
                .array();
    }

}
