package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.RequestContractFunction;
import at.qubic.api.domain.qearn.Qearn;
import lombok.Builder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
public class GetUserLockInfo extends RequestContractFunction {

    static final short INPUT_SIZE = 36;
    private final byte[] publicKey; // unit8[32] => unsigned char[32] => byte[32]
    private final int epoch; // uint32 - 4 byte

    private GetUserLockInfo(byte[] publicKey, int epoch) {
        super(Qearn.CONTRACT_INDEX, Qearn.Function.QEARN_GET_USER_LOCKED_INFO.getCode());
        this.publicKey = publicKey;
        this.epoch = epoch;
    }

    @Override
    protected byte[] toBytes() {
        return ByteBuffer.allocate(INPUT_SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .put(publicKey)
                .putInt(epoch)
                .array();
    }

}
