package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.RequestContractFunction;
import at.qubic.api.domain.qearn.Qearn;
import lombok.Builder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
public class GetUserLockStatus extends RequestContractFunction {

    static final short INPUT_SIZE = 32;
    private final byte[] publicKey; // byte[32]

    public GetUserLockStatus(byte[] publicKey) {
        super(Qearn.CONTRACT_INDEX, Qearn.Function.QEARN_GET_USER_LOCKED_STATE.getCode());
        this.publicKey = publicKey;

    }

    @Override
    protected byte[] toBytes() {
        return ByteBuffer.allocate(INPUT_SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .put(publicKey)
                .array();
    }

}
