package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.TransactionExtraData;
import at.qubic.api.domain.qearn.Qearn;
import lombok.Builder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
public class UnlockRequest implements TransactionExtraData {

    static final short INPUT_SIZE = 12;
    private final long amount;
    private final int epoch;

    @Override
    public long getAmount() {
        return 0; // qearn does not return amount
    }

    @Override
    public short getInputType() {
        return Qearn.Procedure.QEARN_UNLOCK.getCode();
    }

    @Override
    public byte[] toBytes() {
        return ByteBuffer.allocate(INPUT_SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putLong(amount)
                .putInt(epoch)
                .array();
    }
}
