package at.qubic.api.domain.qearn.response;

import lombok.Builder;
import lombok.Data;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
@Data
public class EndedStatus {

    private final long fullyUnlockedAmount;
    private final long fullyRewardedAmount;
    private final long earlyUnlockedAmount;
    private final long earlyRewardedAmount;

    public static EndedStatus fromBytes(byte[] input) {
        ByteBuffer buffer = ByteBuffer.wrap(input);
        buffer.order(ByteOrder.LITTLE_ENDIAN);
        EndedStatus response = fromBuffer(buffer);
        assert buffer.remaining() == 0;
        return response;
    }

    private static EndedStatus fromBuffer(ByteBuffer buffer) {
        return EndedStatus.builder()
                .fullyUnlockedAmount(buffer.getLong())
                .fullyRewardedAmount(buffer.getLong())
                .earlyUnlockedAmount(buffer.getLong())
                .earlyRewardedAmount(buffer.getLong())
                .build();
    }

}
