package at.qubic.api.domain.qearn.response;

import at.qubic.api.domain.qearn.Qearn;
import lombok.Builder;
import lombok.Data;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
@Data
public class QearnProcedureResponse {

    private final int returnCode;

    public static QearnProcedureResponse fromBytes(byte[] input) {
        ByteBuffer buffer = ByteBuffer.wrap(input);
        buffer.order(ByteOrder.LITTLE_ENDIAN);
        QearnProcedureResponse response = fromBuffer(buffer);
        assert buffer.remaining() == 0;
        return response;
    }

    private static QearnProcedureResponse fromBuffer(ByteBuffer buffer) {
        return QearnProcedureResponse.builder()
                .returnCode(buffer.getInt())
                .build();
    }

    public Qearn.ProcedureStatus getReturnStatus() {
        return Qearn.ProcedureStatus.getProcedureStatus(returnCode);
    }

}
