package at.qubic.api.domain.qearn.response;

import lombok.Builder;
import lombok.Data;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
@Data
public class UserLockInfo {

    private final long lockedAmount;

    public static UserLockInfo fromBytes(byte[] input) {
        ByteBuffer buffer = ByteBuffer.wrap(input);
        buffer.order(ByteOrder.LITTLE_ENDIAN);
        UserLockInfo response = fromBuffer(buffer);
        assert buffer.remaining() == 0;
        return response;
    }

    private static UserLockInfo fromBuffer(ByteBuffer buffer) {
        return UserLockInfo.builder()
                .lockedAmount(buffer.getLong())
                .build();
    }

}
