package at.qubic.api.domain.qx;

import lombok.Getter;

public class Qx {

    public static final int CONTRACT_INDEX = 1;
    public static final String ADDRESS = "BAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAARMID";
    public static final byte[] ADDRESS_PUBLIC_KEY = new byte[] {
            1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    @Getter
    public enum Function { // see qx.cpp in qli-client

        QX_GET_FEE(1),
        QX_GET_ASSET_ASK_ORDER(2),
        QX_GET_ASSET_BID_ORDER(3),
        QX_GET_ENTITY_ASK_ORDER(4),
        QX_GET_ENTITY_BID_ORDER(5);

        private final short code;

        Function(int code) {
            this.code = (short) code;
        }
    }

    @Getter
    public enum Procedure { // see qx.cpp in qli-client

        QX_ISSUE_ASSET(1, "issue asset"),
        QX_TRANSFER_SHARE(2, "transfer asset"),
        QX_ADD_ASK_ORDER(5, "add ask"),
        QX_ADD_BID_ORDER(6, "add bid"),
        QX_REMOVE_ASK_ORDER(7, "remove ask"),
        QX_REMOVE_BID_ORDER(8, "remove bid");

        private final short code;
        private final String description;

        Procedure(int code, String description) {
            this.code = (short) code;
            this.description = description;
        }

        public static Procedure fromCode(int code) {
            for (Procedure procedure : Procedure.values()) {
                if (procedure.code == code) {
                    return procedure;
                }
            }
            throw new IllegalArgumentException("Unknown procedure code: " + code);
        }
    }

}
