package at.qubic.api.domain.qx.request;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;
import at.qubic.api.domain.qx.Qx;

@ToString
@Builder
public class QxAddBidOrder implements QxAssetOrder {

    @Getter
    private final QxAssetOrderData orderData;

    @Override
    public byte[] toBytes() {
        return orderData.toBytes();
    }

    @Override
    public short getInputType() {
        return Qx.Procedure.QX_ADD_BID_ORDER.getCode();
    }

    @Override
    public long getAmount() {
        // we need to lock the amount for the order
        return orderData.getPrice() * orderData.getNumberOfShares();
    }

}
