package at.qubic.api.domain.qx.request;

import lombok.Getter;
import lombok.extern.slf4j.Slf4j;
import at.qubic.api.domain.qx.Qx;
import at.qubic.api.domain.RequestContractFunction;
import at.qubic.api.util.AssetUtil;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Slf4j
public abstract class QxGetAssetOrders extends RequestContractFunction {

    static final short INPUT_SIZE = (short) 48;
    private final byte[] assetIssuer; // unit8_t issuer[32] - public key
    @Getter
    private final String assetName; // 8 bytes - unint64_t assetName;
    @Getter
    private final long offset; // unint64_t offset;

    public QxGetAssetOrders(Qx.Function function, byte[] assetIssuer, String assetName, long offset) {
        super(Qx.CONTRACT_INDEX, function.getCode());
        this.assetIssuer = assetIssuer;
        this.assetName = assetName;
        this.offset = offset;
    }

    protected byte[] toBytes() {
        return ByteBuffer.allocate(INPUT_SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .put(assetIssuer)
                .put(AssetUtil.nameTo8Bytes(assetName))
                .putLong(offset)
                .array();
    }

}
