package at.qubic.api.domain.std.request;

import lombok.Builder;
import lombok.Getter;
import lombok.ToString;
import at.qubic.api.domain.QubicRequest;
import at.qubic.api.domain.MessageType;
import at.qubic.api.domain.std.SignedTransaction;

@Builder
@Getter
@ToString(onlyExplicitlyIncluded = true)
public class BroadcastTransaction extends QubicRequest {

    @ToString.Include
    private final SignedTransaction transaction;

    @Override
    public MessageType getMessageType() {
        return MessageType.BROADCAST_TRANSACTION;
    }

    @Override
    public byte[] getMessagePayload() {
        return transaction.toBytes();
    }

    @Override
    public boolean isZeroDejaVu() {
        return true;
    }

}
