package at.qubic.api.domain.std.request;

import at.qubic.api.domain.MessageType;
import at.qubic.api.domain.QubicRequest;
import lombok.ToString;

import static at.qubic.api.domain.MessageType.REQUEST_ASSETS;

@ToString
public abstract class RequestAssets extends QubicRequest {

    protected static final int SIZE = 112;

    public enum RequestType {
        // ordinal as short is correct type
        REQUEST_TYPE_ISSUANCE_RECORDS,
        REQUEST_TYPE_OWNERSHIP_RECORDS,
        REQUEST_TYPE_POSSESSION_RECORDS,
        REQUEST_BY_UNIVERSE_INDEX;

        public short asShort() {
            return (short) ordinal();
        }
    }

    @Override
    public MessageType getMessageType() {
        return REQUEST_ASSETS;
    }

}
