package at.qubic.api.domain.std.request;

import lombok.Builder;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static at.qubic.api.domain.std.request.RequestAssets.RequestType.REQUEST_BY_UNIVERSE_INDEX;

@Builder
public class RequestAssetsByIndex extends RequestAssets {

    private static final int SIZE = 112;

    private final int universeIndex; // unsigned int

    @Override
    protected byte[] getMessagePayload() {
        return ByteBuffer.allocate(SIZE)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putShort(REQUEST_BY_UNIVERSE_INDEX.asShort())
                .putShort((short) 0) // no flags
                .putInt(universeIndex)
                .array();
    }

}
