package at.qubic.api.domain.std.request;

import lombok.Builder;
import lombok.ToString;
import at.qubic.api.domain.QubicRequest;
import at.qubic.api.domain.MessageType;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
@ToString(onlyExplicitlyIncluded = true)
public class RequestTickData extends QubicRequest {

    @ToString.Include
    private final int tick;

    @Override
    public MessageType getMessageType() {
        return MessageType.REQUEST_TICK_DATA;
    }

    @Override
    public byte[] getMessagePayload() {
        return ByteBuffer.allocate(4)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putInt(tick)
                .array();
    }

}

