package at.qubic.api.domain.std.response;

import lombok.Builder;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.ToString;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Builder
@Getter
@EqualsAndHashCode
@ToString
public class AssetOwnershipResponse {

    private final AssetOwnership asset;
    private final int tick; // unsigned int - 4 bytes
    private final int universeIndex; // unsigned int - 4 bytes

    public static AssetOwnershipResponse fromBytes(byte[] bytes) {
        ByteBuffer buf = ByteBuffer.wrap(bytes);
        buf.order(ByteOrder.LITTLE_ENDIAN);
        AssetOwnershipResponse assets = AssetOwnershipResponse.builder()
                .asset(AssetOwnership.fromByteBuffer(buf))
                .tick(buf.getInt())
                .universeIndex(buf.getInt())
                .build();
        assert buf.remaining() == 0 : buf.remaining();
        return assets;
    }
}
