package at.qubic.api.network;

import lombok.extern.slf4j.Slf4j;
import at.qubic.api.domain.std.response.TickInfo;
import reactor.core.publisher.Mono;

import java.time.Instant;
import java.util.Collection;

@Slf4j
public class NoopNetworkStatus implements NetworkStatus {

    private final TickInfo tickInfo = TickInfo.builder()
            .epoch(INITIAL_EPOCH)
            .tick(INITIAL_TICK)
            .build();

    @Override
    public Mono<TickInfo> update(Collection<Node> nodes) {
        return Mono.just(tickInfo);
    }

    @Override
    public Mono<TickStatus> getTickStatus() {
        return Mono.just(TickStatus.builder()
                .latestUpdate(Instant.now())
                .tickInfo(tickInfo)
                .build());
    }

}
