package at.qubic.api.network;

import at.qubic.api.domain.std.response.TickInfo;

import java.util.Comparator;

public class TickComparator implements Comparator<TickInfo> {

    @Override
    public int compare(TickInfo t1, TickInfo t2) {
        final Comparator<TickInfo> epochComparator = Comparator.comparingInt(TickInfo::getEpoch);
        final Comparator<TickInfo> tickComparator = Comparator.comparingInt(TickInfo::getTick);
        int epochCompareResult = epochComparator.compare(t1, t2);
        return epochCompareResult == 0 ? tickComparator.compare(t1, t2) : epochCompareResult;
    }

}
