package at.qubic.api.network;

import lombok.Builder;
import lombok.Value;
import at.qubic.api.domain.std.response.TickInfo;

import java.time.Instant;

@Builder
@Value
public class TickStatus {

    @Builder.Default
    Instant latestUpdate = Instant.EPOCH;
    @Builder.Default
    TickInfo tickInfo = TickInfo.builder().build();

    public boolean isValid() {
        return tickInfo.getEpoch() > 0
                && tickInfo.getTick() > 0
                && latestUpdate != Instant.EPOCH;
    }

    public boolean lastUpdatedBefore(Instant when) {
        return latestUpdate.isBefore(when);
    }

}
