package at.qubic.api.tcp;

import io.netty.handler.codec.LengthFieldBasedFrameDecoder;

import java.nio.ByteOrder;

/**
 * Decodes TCP messages so that every qubic message is packed into one byte buffer. One TCP package can contain multiple messages or
 * one message can be split over multiple packages. With this frame decoder one message will be packed into one byte buffer for easier
 * processing.
 */
public class QubicHeaderFrameDecoder extends LengthFieldBasedFrameDecoder {

    public QubicHeaderFrameDecoder() {
        // size info is 24 bits (3 bytes) at the beginning of the message in little endian.
        // max frame length: get tick data including header is 41336 bytes.
        super(ByteOrder.LITTLE_ENDIAN, 41336, 0, 3, -3, 0, true);
    }

}
