package at.qubic.api.tcp;

import io.netty.channel.ChannelOption;
import io.netty.handler.logging.LogLevel;
import lombok.extern.slf4j.Slf4j;
import reactor.netty.tcp.TcpClient;

import java.time.Duration;

@Slf4j
public class TcpClientFactory {

    public static TcpClient tcpClient(String host, int port) {
        return TcpClient.create()
                .option(ChannelOption.CONNECT_TIMEOUT_MILLIS, (int) Duration.ofSeconds(3).toMillis())
                .option(ChannelOption.TCP_FASTOPEN_CONNECT, true)
                .wiretap("at.qubic.api.tcp", LogLevel.DEBUG)
                .doOnConnected(connection -> connection.addHandlerFirst("qubic-frame-decoder", new QubicHeaderFrameDecoder()))
                .host(host)
                .port(port);
    }

}
