package at.qubic.api.crypto.jna;

import com.sun.jna.Memory;
import com.sun.jna.Native;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;

import static org.apache.commons.codec.binary.Hex.decodeHex;
import static org.assertj.core.api.Assertions.assertThat;

@Slf4j
class QubicFourQLibTest {

    private final QubicCryptoLib lib = Native.load("fourq-qubic", QubicCryptoLib.class);

    @Test
    void ecc_mul_fixed_and_decode_with_pointer() throws Exception {
        final byte[] privateKey = decodeHex("969ea207cc1e1a0e1801b3c4941af919c67ab4f4b3cc6bf5a680709bae5d378e");

        final Memory p = new Memory(64);
        final byte[] publicKey = new byte[32];
        lib.ecc_mul_fixed(privateKey, p);
        lib.encode(p, publicKey);

        assertThat(publicKey).isEqualTo(decodeHex("7fac844c525271704f35a9f5a5702a5c93b17ed8a5c0a6287e1dbdd321111f1b"));
    }

}