package at.qubic.api.domain.event.response;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.crypto.NoCrypto;
import org.bouncycastle.util.encoders.Base64;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.*;

class AssetIssuanceEventTest {

    private final IdentityUtil identityUtil = new IdentityUtil(true, new NoCrypto());

    @Test
    void fromBytes() {
        byte[] input = Base64.decode("fBUfs37FBf00y/XqDc6kE/JNnjpN0DDl2QR/r0BhsKpAb0ABAAAAAFFDQVAAAAAAAAAAAAAAAA==");
        AssetIssuanceEvent result = AssetIssuanceEvent.fromBytes(input);
        assertThat(result).isNotNull();
        assertThat(result).isEqualTo(AssetIssuanceEvent.builder()
                        .name("QCAP")
                        .numberOfShares(21_000_000)
                        .issuerPublicKey(identityUtil.getPublicKeyFromIdentity("QCAPWMYRSHLBJHSTTZQVCIBARVOASKDENASAKNOBRGPFWWKRCUVUAXYEZVOG"))
                        .numberOfDecimalPlaces((byte) 0)
                        .unitOfMeasurement("0000000")
                .build());
    }

}