package at.qubic.api.domain.event.response;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.crypto.NoCrypto;
import org.bouncycastle.util.encoders.Base64;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.*;

class QuTransferEventTest {

    private final IdentityUtil identityUtil = new IdentityUtil(true, new NoCrypto());

    @Test
    void fromBytes() {

        byte[] bytes = Base64.decode("jo0AwIVOmnDHyw6JCcNWOuWlngm9zxDGrtcyA3WjioYBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAEBCDwAAAAAA");
        QuTransferEvent result = QuTransferEvent.fromBytes(bytes);

        assertThat(result).isNotNull();
        assertThat(result).isEqualTo(QuTransferEvent.builder()
                .sourcePublicKey(identityUtil.getPublicKeyFromIdentity("KEFDZTYLFERAHDVLNQORDHFQIBSBZCWSZXZFFANOTFAHWMOVGTRQJPXDVCWG"))
                .destinationPublicKey(identityUtil.getPublicKeyFromIdentity("BAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAARMID"))
                .amount(1_000_000)
                .build());

    }

}