package at.qubic.api.domain.event.response;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.crypto.NoCrypto;
import org.bouncycastle.util.encoders.Base64;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.*;

class QxTradeMessageEventTest {

    private final IdentityUtil identityUtil = new IdentityUtil(true, new NoCrypto());

    @Test
    void fromBytes() {

        byte[] input = Base64.decode("AQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAE1MTQAAAAAAAcLrCwAAAAABAAAAAAAAAA==");
        QxTradeMessageEvent event = QxTradeMessageEvent.fromBytes(input);
        assertThat(event).isNotNull();
        assertThat(event).isEqualTo(QxTradeMessageEvent.builder()
                        .contractIndex(1) // QX
                        .type(0) // trade message
                        .issuer(identityUtil.getPublicKeyFromIdentity("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAFXIB"))
                        .assetName("MLM")
                        .price(200_000_001)
                        .numberOfShares(1)
                .build());

    }
}