package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.qearn.Qearn;
import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class GetBurnedAndBoostedStatsTest {

    @Test
    void getMessagePayload() {
        GetBurnedAndBoostedStats stats = new GetBurnedAndBoostedStats();
        byte[] bytes = stats.getMessagePayload();
        assertThat(bytes).hasSize(8);
        ByteBuffer buffer = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
        assertThat(buffer.getInt()).isEqualTo(Qearn.CONTRACT_INDEX);
        assertThat(buffer.getShort()).isEqualTo(Qearn.Function.QEARN_GET_BURNED_AND_BOOSTED_STATS.getCode());
        assertThat(buffer.getShort()).isEqualTo((short) 0);
    }

    @Test
    void toBytes() {
        assertThat(new GetBurnedAndBoostedStats().toBytes()).isEqualTo(new byte[0]);
    }

}