package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.qearn.Qearn;
import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class GetStatsForEpochTest {

    @Test
    void getMessagePayload() {
        byte[] bytes = testRequest().getMessagePayload();
        assertThat(bytes).hasSize(12);

        ByteBuffer buffer = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
        assertThat(buffer.getInt()).isEqualTo(Qearn.CONTRACT_INDEX);
        assertThat(buffer.getShort()).isEqualTo(Qearn.Function.QEARN_GET_STATS.getCode());
        assertThat(buffer.getShort()).isEqualTo(GetLockInfoForEpoch.INPUT_SIZE);
        assertThat(buffer.remaining()).isEqualTo(GetLockInfoForEpoch.INPUT_SIZE); // see toBytes()
    }

    @Test
    void toBytes() {
        byte[] bytes = testRequest().toBytes();
        assertThat(bytes).hasSize(GetStatsForEpoch.INPUT_SIZE);
        ByteBuffer buffer = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
        assertThat(buffer.getInt()).isEqualTo(142);
    }

    private static GetStatsForEpoch testRequest() {
        return GetStatsForEpoch.builder()
                .epoch(142)
                .build();
    }

}