package at.qubic.api.domain.qearn.request;

import at.qubic.api.domain.qearn.Qearn;
import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class UnlockRequestTest {

    @Test
    void getInputType() {
        UnlockRequest request = UnlockRequest.builder().build();
        assertThat(request.getInputType()).isEqualTo(Qearn.Procedure.QEARN_UNLOCK.getCode());
    }

    @Test
    void toBytes() {
        byte[] bytes = UnlockRequest.builder()
                .epoch(123)
                .amount(1_000_000)
                .build()
                .toBytes();

        assertThat(bytes).hasSize(UnlockRequest.INPUT_SIZE);
        ByteBuffer buffer = ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN);
        assertThat(buffer.getLong()).isEqualTo(1_000_000);
        assertThat(buffer.getInt()).isEqualTo(123);
    }

    @Test
    void getAmount() {
        UnlockRequest request = UnlockRequest.builder().amount(1_000_000).build();
        assertThat(request.getAmount()).isEqualTo(0); // payload amount is not transaction amount!
    }
}