package at.qubic.api.domain.qearn.response;

import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class EndedStatusTest {

    @Test
    void fromBytes() {

        byte[] bytes = ByteBuffer.allocate(4 * 8)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putLong(1)
                .putLong(2)
                .putLong(3)
                .putLong(4)
                .array();

        EndedStatus status = EndedStatus.fromBytes(bytes);
        assertThat(status).isNotNull();
        assertThat(status.getFullyUnlockedAmount()).isEqualTo(1);
        assertThat(status.getFullyRewardedAmount()).isEqualTo(2);
        assertThat(status.getEarlyUnlockedAmount()).isEqualTo(3);
        assertThat(status.getEarlyRewardedAmount()).isEqualTo(4);
    }

}