package at.qubic.api.domain.qearn.response;

import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class LockInfoForEpochTest {

    @Test
    void fromBytes() {
        byte[] bytes = ByteBuffer.allocate(40)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putLong(1)
                .putLong(2)
                .putLong(3)
                .putLong(4)
                .putLong(5)
                .array();

        LockInfoForEpoch lockInfo = LockInfoForEpoch.fromBytes(bytes);
        assertThat(lockInfo.getLockedAmount()).isEqualTo(1);
        assertThat(lockInfo.getBonusAmount()).isEqualTo(2);
        assertThat(lockInfo.getCurrentLockedAmount()).isEqualTo(3);
        assertThat(lockInfo.getCurrentBonusAmount()).isEqualTo(4);
        assertThat(lockInfo.getYield()).isEqualTo(5);
    }

    @Test
    void getYieldPercentage() {
        LockInfoForEpoch lockInfo = LockInfoForEpoch.builder()
                .yield(123456)
                .build();

        assertThat(lockInfo.getYieldPercentage()).isEqualTo("1.23456");
    }

}