package at.qubic.api.domain.qearn.response;

import at.qubic.api.domain.qearn.Qearn;
import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class QearnProcedureResponseTest {

    @Test
    void fromBytes() {
        byte[] bytes = ByteBuffer.allocate(4)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putInt(1)
                .array();

        QearnProcedureResponse response = QearnProcedureResponse.fromBytes(bytes);
        assertThat(response.getReturnCode()).isEqualTo(1);
    }

    @Test
    void getReturnStatus() {
        QearnProcedureResponse response = QearnProcedureResponse.builder().returnCode(5).build();
        assertThat(response.getReturnStatus()).isEqualTo(Qearn.ProcedureStatus.QEARN_UNLOCK_SUCCESS);
    }

}