package at.qubic.api.domain.qx;

import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.*;

class QxTest {

    @Test
    void contractIndex() {
        assertThat(Qx.CONTRACT_INDEX).isOne();
    }

    @Test
    void getFunctionCodes() {
        assertThat(Qx.Function.QX_GET_FEE.getCode()).isEqualTo((short) 1);
        assertThat(Qx.Function.QX_GET_ASSET_ASK_ORDER.getCode()).isEqualTo((short) 2);
        assertThat(Qx.Function.QX_GET_ASSET_BID_ORDER.getCode()).isEqualTo((short) 3);
        assertThat(Qx.Function.QX_GET_ENTITY_ASK_ORDER.getCode()).isEqualTo((short) 4);
        assertThat(Qx.Function.QX_GET_ENTITY_BID_ORDER.getCode()).isEqualTo((short) 5);
    }

    @Test
    void getProcedureCodes() {
        assertThat(Qx.Procedure.QX_ISSUE_ASSET.getCode()).isEqualTo((short) 1);
        assertThat(Qx.Procedure.QX_TRANSFER_SHARE.getCode()).isEqualTo((short) 2);
        assertThat(Qx.Procedure.QX_ADD_ASK_ORDER.getCode()).isEqualTo((short) 5);
        assertThat(Qx.Procedure.QX_ADD_BID_ORDER.getCode()).isEqualTo((short) 6);
        assertThat(Qx.Procedure.QX_REMOVE_ASK_ORDER.getCode()).isEqualTo((short) 7);
        assertThat(Qx.Procedure.QX_REMOVE_BID_ORDER.getCode()).isEqualTo((short) 8);
    }

}