package at.qubic.api.domain.qx.request;

import at.qubic.api.domain.qx.Qx;
import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.assertThat;

class QxGetEntityAskOrdersTest {

    @Test
    void getMessagePayload() {
        byte[] orderEntity = new byte[32];
        orderEntity[2] = 2;
        QxGetEntityAskOrders getOrders = new QxGetEntityAskOrders(orderEntity,123);
        byte[] payload = getOrders.getMessagePayload();
        assertThat(payload).hasSize(48);

        ByteBuffer buffer = ByteBuffer.wrap(payload).order(ByteOrder.LITTLE_ENDIAN);

        assertThat(buffer.getInt()).isEqualTo(Qx.CONTRACT_INDEX);
        assertThat(buffer.getShort()).isEqualTo(Qx.Function.QX_GET_ENTITY_ASK_ORDER.getCode());
        assertThat(buffer.getShort()).isEqualTo(QxGetEntityOrders.INPUT_SIZE);

        byte[] entity = new byte[32];
        buffer.get(entity);
        assertThat(entity).isEqualTo(orderEntity);

        assertThat(buffer.getLong()).isEqualTo(123);
    }

}