package at.qubic.api.domain.qx.response;

import org.junit.jupiter.api.Test;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import static org.assertj.core.api.Assertions.*;

class QxFeesTest {

    @Test
    void fromBytes() {
        QxFees expected = QxFees.builder()
                .assetIssuanceFee(1_000_000_000)
                .transferFee(1_000_000)
                .tradeFee(5_000_000)
                .build();

        QxFees result = QxFees.fromBytes(ByteBuffer.allocate(12)
                .order(ByteOrder.LITTLE_ENDIAN)
                .putInt(1_000_000_000)
                .putInt(1_000_000)
                .putInt(5_000_000)
                .array()
        );

        assertThat(result).isEqualTo(expected);
    }

    @Test
    void getTradeFeePercentage() {
        QxFees fees = QxFees.builder()
                .tradeFee(5_000_000)
                .build();
        assertThat(fees.getTradeFeePercentage()).isEqualTo("0.5");
    }

}