package at.qubic.api.domain.std.request;

import org.junit.jupiter.api.Test;
import at.qubic.api.domain.MessageType;
import at.qubic.api.domain.QubicHeader;
import at.qubic.api.domain.QubicMessage;
import at.qubic.api.domain.std.SignedTransaction;
import at.qubic.api.domain.std.Transaction;

import static org.assertj.core.api.Assertions.assertThat;
import static at.qubic.api.domain.QubicHeader.HEADER_LENGTH;

class BroadcastTransactionTest {

    @Test
    void createMessage_broadcastTransaction() {
        SignedTransaction transaction = SignedTransaction.builder()
                .transaction(Transaction.builder().build())
                .build();
        BroadcastTransaction broadcastTransaction = BroadcastTransaction.builder()
                .transaction(transaction)
                .build();

        QubicMessage message = broadcastTransaction.toMessage();
        assertThat(message.getHeader()).isEqualTo(QubicHeader.builder()
                .type(MessageType.BROADCAST_TRANSACTION)
                .size(HEADER_LENGTH + 80)
                .dejavu(0)
                .build());
        assertThat(message.getPayload()).isEqualTo(transaction.toBytes());
    }


}