package at.qubic.api.domain.std.request;

import at.qubic.api.domain.MessageType;
import at.qubic.api.domain.QubicMessage;
import org.bouncycastle.util.encoders.Hex;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class RequestAssetsByIndexTest {

    @Test
    void getMessagePayload() {
        String hex = "03000000040000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
        RequestAssetsByIndex request = RequestAssetsByIndex.builder().universeIndex(4).build();
        byte[] expected = Hex.decode(hex);
        assertThat(request.getMessagePayload()).isEqualTo(expected);
    }

    @Test
    void toMessageBytes() {
        RequestAssetsByIndex request = RequestAssetsByIndex.builder().universeIndex(4).build();
        QubicMessage message = request.toMessage();
        assertThat(message.getHeader().getType()).isEqualTo(MessageType.REQUEST_ASSETS);
        assertThat(message.getHeader().getSize()).isEqualTo(RequestAssets.SIZE + 8);
        assertThat(message.getHeader().getDejavu()).isPositive();
    }

}