package at.qubic.api.domain.std.request;

import org.junit.jupiter.api.Test;
import at.qubic.api.domain.QubicMessage;

import static org.assertj.core.api.Assertions.assertThat;
import static at.qubic.api.domain.MessageType.REQUEST_CURRENT_TICK_INFO;
import static at.qubic.api.domain.QubicHeader.HEADER_LENGTH;

class RequestCurrentTickInfoTest {

    @Test
    void createMessage_requestCurrentTickInfo() {
        QubicMessage message = RequestCurrentTickInfo.builder().build().toMessage();
        assertThat(message.getHeader().getType()).isEqualTo(REQUEST_CURRENT_TICK_INFO);
        assertThat(message.getHeader().getSize()).isEqualTo(HEADER_LENGTH);
        assertThat(message.getHeader().getDejavu()).isPositive();
        assertThat(message.getPayload()).isEmpty();
    }

}