package at.qubic.api.domain.std.request;

import org.junit.jupiter.api.Test;
import at.qubic.api.domain.QubicMessage;

import java.util.Random;

import static org.assertj.core.api.Assertions.assertThat;
import static at.qubic.api.domain.MessageType.REQUEST_ENTITY;
import static at.qubic.api.domain.QubicHeader.HEADER_LENGTH;

class RequestEntityTest {

    @Test
    void createMessage_requestEntity() {
        final byte[] publicKey = randomBytes();
        QubicMessage message = RequestEntity.builder().publicKey(publicKey).build().toMessage();
        assertThat(message.getHeader().getType()).isEqualTo(REQUEST_ENTITY);
        assertThat(message.getHeader().getSize()).isEqualTo(HEADER_LENGTH + 32);
        assertThat(message.getHeader().getDejavu()).isPositive();
        assertThat(message.getPayload()).isEqualTo(publicKey);
    }

    private static byte[] randomBytes() {
        byte[] publicKey = new byte[32];
        new Random().nextBytes(publicKey);
        return publicKey;
    }

}