package at.qubic.api.domain.std.request;

import org.junit.jupiter.api.Test;
import at.qubic.api.domain.QubicMessage;

import static org.assertj.core.api.Assertions.assertThat;
import static at.qubic.api.domain.MessageType.REQUEST_TICK_DATA;
import static at.qubic.api.domain.QubicHeader.HEADER_LENGTH;

class RequestTickDataTest {

    @Test
    void createMessage_requestTickData() {
        final RequestTickData requestTickData = RequestTickData.builder().tick(42).build();
        QubicMessage message = requestTickData.toMessage();
        assertThat(message.getHeader().getType()).isEqualTo(REQUEST_TICK_DATA);
        assertThat(message.getHeader().getSize()).isEqualTo(HEADER_LENGTH + 4);
        assertThat(message.getHeader().getDejavu()).isPositive();
        assertThat(message.getPayload()).isEqualTo(requestTickData.getMessagePayload());
    }

}