package at.qubic.api.domain.std.request;

import org.junit.jupiter.api.Test;
import at.qubic.api.domain.QubicMessage;

import static org.assertj.core.api.Assertions.assertThat;
import static at.qubic.api.domain.MessageType.REQUEST_TICK_TRANSACTIONS;
import static at.qubic.api.domain.QubicHeader.HEADER_LENGTH;

class RequestTickTransactionsTest {

    @Test
    void createMessage_requestTickTransactions() {
        final RequestTickTransactions requestTickTransactions = RequestTickTransactions.builder().tick(42).build();
        QubicMessage message = requestTickTransactions.toMessage();
        assertThat(message.getHeader().getType()).isEqualTo(REQUEST_TICK_TRANSACTIONS);
        assertThat(message.getHeader().getSize()).isEqualTo(HEADER_LENGTH + 132);
        assertThat(message.getHeader().getDejavu()).isPositive();
        assertThat(message.getPayload()).isEqualTo(requestTickTransactions.getMessagePayload());
    }

}