package at.qubic.api.domain.std.response;

import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class ExchangePublicPeersTest {

    @Test
    void fromBytes_thenCreateIps() {
        byte[] input = new byte[] {95, -100, -26, -82, 88, -38, -32, 55, -112, 2, 106, -93, 88, -58, 25, 67};
        final ExchangePublicPeers result = ExchangePublicPeers.fromBytes(input);
        assertThat(result.getPeers()[0]).isEqualTo("95.156.230.174");
        assertThat(result.getPeers()[1]).isEqualTo("88.218.224.55");
        assertThat(result.getPeers()[2]).isEqualTo("144.2.106.163");
        assertThat(result.getPeers()[3]).isEqualTo("88.198.25.67");
    }

    @Test
    void toBytes_thenEqualsFromBytes() {

        final ExchangePublicPeers original = ExchangePublicPeers.builder().peers(new String[]{
                "95.156.230.174",
                "88.218.224.55",
                "144.2.106.163",
                "88.198.25.67"
        }).build();

        assertThat(ExchangePublicPeers.fromBytes(original.toBytes().array())).isEqualTo(original);

    }

}