package at.qubic.api.domain.std.response;

import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import at.qubic.api.util.TestFileUtil;

import static org.assertj.core.api.Assertions.*;

@Slf4j
class RespondOwnedAssetsTest {

    @Test
    void fromBytes() {

        byte[] payload = TestFileUtil.loadHexFile("/testdata/domain/respond-owned-asset-payload.hex");
        RespondOwnedAssets respondOwnedAssets = RespondOwnedAssets.fromBytes(payload);

        assertThat(respondOwnedAssets).isNotNull();
        log.info(respondOwnedAssets.toString());
        AssetOwnership asset = respondOwnedAssets.getAsset();
        assertThat(asset).isNotNull();
        AssetIssuance issuanceAsset = respondOwnedAssets.getIssuanceAsset();
        assertThat(issuanceAsset).isNotNull();

        assertThat(respondOwnedAssets.getTick()).isEqualTo(14409263);
        assertThat(respondOwnedAssets.getUniverseIndex()).isEqualTo(11237188);
        assertThat(respondOwnedAssets.getSiblings()).isNotEmpty();
    }

}