package at.qubic.api.domain.std.response;

import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import at.qubic.api.util.TestFileUtil;

import static org.assertj.core.api.Assertions.assertThat;

@Slf4j
class RespondPossessedAssetsTest {

    @Test
    void fromBytes() {

        byte[] payload = TestFileUtil.loadHexFile("/testdata/domain/respond-possessed-asset-payload.hex");
        RespondPossessedAssets responsePossessedAssets = RespondPossessedAssets.fromBytes(payload);
        assertThat(responsePossessedAssets).isNotNull();
        log.info(responsePossessedAssets.toString());
        AssetPossession possession = responsePossessedAssets.getAsset();
        assertThat(possession).isNotNull();
        AssetOwnership ownership = responsePossessedAssets.getOwnershipAsset();
        assertThat(ownership).isNotNull();
        AssetIssuance issuance = responsePossessedAssets.getIssuanceAsset();
        assertThat(issuance).isNotNull();

        assertThat(responsePossessedAssets.getTick()).isEqualTo(14440439);
        assertThat(responsePossessedAssets.getUniverseIndex()).isEqualTo(11237189);
        assertThat(responsePossessedAssets.getSiblings()).isNotEmpty();
    }

}