package at.qubic.api.domain.std.response;

import org.apache.commons.codec.binary.Hex;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;

class TickInfoTest {

    @Test
    void fromBytes() throws Exception {
        byte[] bytes = Hex.decodeHex("68036d009231d6007802000068a3d500");
        final TickInfo tickInfo = TickInfo.fromBytes(bytes);
        assertThat(tickInfo).isNotNull();
        assertThat(tickInfo.getTick()).isEqualTo(14037394);
        assertThat(tickInfo.getEpoch()).isEqualTo((short) 109);
        assertThat(tickInfo.getTickDuration()).isEqualTo((short) 872);
        assertThat(tickInfo.getNumberOfAlignedVotes()).isEqualTo((short) 632);
        assertThat(tickInfo.getNumberOfMisalignedVotes()).isEqualTo((short) 0);
        assertThat(tickInfo.getInitialTick()).isEqualTo(14001000);
    }

    @Test
    void toByteBuffer() throws Exception {
        final TickInfo ti = TickInfo.builder()
                .tick(14037394)
                .epoch((short) 109)
                .tickDuration((short) 872)
                .numberOfAlignedVotes((short) 632)
                .numberOfMisalignedVotes((short) 0)
                .initialTick(14001000)
                .build();
        assertThat(ti.toByteBuffer().array()).isEqualTo(Hex.decodeHex("68036d009231d6007802000068a3d500"));
    }

}