package at.qubic.api.network;

import org.junit.jupiter.api.Test;

import java.util.Collection;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.*;

class PublicNodesStrategyTest {

    private final NetworkStatus networkStatus = mock();
    private final PublicNodesStrategy publicNodesStrategy = new PublicNodesStrategy(networkStatus);

    @Test
    void addNode_thenAddPeerListener() {
        Node node = publicNodesStrategy.addNode("foo");
        assertThat(node.getPeerListeners()).containsExactly(publicNodesStrategy);
    }

    @Test
    void addPeer() {
        publicNodesStrategy.publishPeers(new String[] {"foo", "bar"});
        Collection<Node> nodes = publicNodesStrategy.nodes.values();
        assertThat(nodes.stream().map(Node::getName)).containsExactlyInAnyOrder("foo", "bar");
    }

}