package at.qubic.api.util;

import lombok.SneakyThrows;
import org.apache.commons.codec.binary.Hex;
import org.apache.commons.io.IOUtils;

import java.nio.charset.StandardCharsets;
import java.util.Objects;

public class TestFileUtil {

    @SneakyThrows
    public static byte[] loadHexFile(String path) {
        return Hex.decodeHex(
                IOUtils.toString(
                        Objects.requireNonNull(
                                TestFileUtil.class.getResourceAsStream(path)
                        ), StandardCharsets.UTF_8));
    }

    @SneakyThrows
    public static byte[] loadBinaryFile(String path) {
        return IOUtils.toByteArray(
                Objects.requireNonNull(
                        TestFileUtil.class.getResourceAsStream(path)
                ));
    }

}
