package at.qubic.api.util;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ArrayUtils;
import at.qubic.api.domain.MessageType;
import at.qubic.api.domain.QubicHeader;
import at.qubic.api.domain.QubicMessage;

import java.util.Objects;

@Slf4j
public class TestMessageFactory {

    public static QubicMessage createMessage(MessageType messageType) {
        return createMessage(messageType, new byte[0]);
    }

    public static QubicMessage createMessage(MessageType messageType, byte[] payload) {
        Objects.requireNonNull(payload);
        QubicHeader.QubicHeaderBuilder qubicHeader = QubicHeader.builder()
                .type(messageType)
                .size(QubicHeader.HEADER_LENGTH + ArrayUtils.getLength(payload));
        return QubicMessage.builder()
                .header(qubicHeader.build())
                .payload(payload)
                .build();
    }

}
