package at.qubic.shell.command;

import lombok.extern.slf4j.Slf4j;
import at.qubic.shell.command.service.WalletService;
import org.springframework.shell.command.annotation.Command;
import org.springframework.shell.command.annotation.Option;

import static at.qubic.shell.command.SharedCommandConstants.OPTION_DESCRIPTION_IDENTITY;
import static org.springframework.shell.command.CommandRegistration.OptionArity.EXACTLY_ONE;

@Command(command = "wallet", group = "wallet")
@Slf4j
public class AddWalletCommand {

    private final WalletService walletService;

    public AddWalletCommand(WalletService walletService) {
        this.walletService = walletService;
    }

    @Command(command = "add", description = "Add a (read only) wallet.")
    public String addWallet(
            @Option(description = OPTION_DESCRIPTION_IDENTITY, arity = EXACTLY_ONE, required = true)
            String identity) {
        return walletService.addWallet(identity);
    }

}
