package at.qubic.shell.command;

import lombok.extern.slf4j.Slf4j;
import at.qubic.shell.command.service.KeyService;
import org.springframework.shell.command.annotation.Command;

@Command(group = "keys")
@Slf4j
public class LockKeyStoreCommand {

    private final KeyService keyManagementService;

    public LockKeyStoreCommand(KeyService walletService) {
        this.keyManagementService = walletService;
    }

    @Command(command = "lock", description = "Lock key store.")
    public String lock() {
        if (!keyManagementService.isLocked()) {
            keyManagementService.lock();
            return "Locked wallet.";
        } else {
            return "Wallet is already locked.";
        }
    }

}
