package at.qubic.shell.completion;

import at.qubic.shell.wallet.Asset;
import at.qubic.shell.wallet.Assets;
import org.springframework.shell.CompletionContext;
import org.springframework.shell.CompletionProposal;
import org.springframework.shell.completion.CompletionProvider;

import java.util.List;

public class AssetNameCompletionProvider implements CompletionProvider {

    private final Assets assets;

    public AssetNameCompletionProvider(Assets assets) {
        this.assets = assets;
    }

    @Override
    public List<CompletionProposal> apply(CompletionContext completionContext) {
        return assets.getAssets().stream()
                .map(Asset::getName)
                .map(CompletionProposal::new)
                .toList();
    }

}
