package at.qubic.shell.component.terminal;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.domain.qx.Qx;
import at.qubic.api.domain.qx.request.QxAssetOrder;
import lombok.extern.slf4j.Slf4j;
import org.jline.terminal.Terminal;

import java.util.function.Supplier;

@Slf4j
public class QxOrderTerminalOutput extends QxTerminalOutput {

    private final QxAssetOrder order;

    public QxOrderTerminalOutput(IdentityUtil identityUtil, Supplier<Terminal> terminalSupplier, String identity, QxAssetOrder order) {
        super(identityUtil, terminalSupplier, identity);
        this.order = order;
    }

    @Override
    public void writeOperationDescription() {
        Qx.Procedure procedure = Qx.Procedure.fromCode(order.getInputType());
        String message = String.format("[%s]: Sending [%s] to QX. Shares [%s], price [%s], asset [%s], issuer [%s].\n",
                source,
                procedure.getDescription(),
                formatUtil.formatUnsigned(order.getOrderData().getNumberOfShares()),
                formatUtil.formatUnsigned(order.getOrderData().getPrice()),
                order.getOrderData().getAssetName(),
                identityUtil.getIdentityFromPublicKey(order.getOrderData().getAssetIssuer()));
        terminalWriter.writeAsync(message);

    }

}
