package at.qubic.shell.component.terminal;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.domain.qx.request.QxTransferAssetOrder;
import lombok.extern.slf4j.Slf4j;
import org.jline.terminal.Terminal;

import java.util.function.Supplier;

@Slf4j
public class QxTransferTerminalOutput extends QxTerminalOutput {

    private final QxTransferAssetOrder transfer;

    public QxTransferTerminalOutput(IdentityUtil identityUtil, Supplier<Terminal> terminalSupplier, String source, QxTransferAssetOrder transfer) {
        super(identityUtil, terminalSupplier, source);
        this.transfer = transfer;
    }

    @Override
    public void writeOperationDescription() {
        String message = String.format("[%s]: Transfering %s [%s]/[%s] to [%s].\n",
                source,
                formatUtil.formatUnsigned(transfer.getNumberOfUnits()),
                transfer.getAssetName(),
                identityUtil.getIdentityFromPublicKey(transfer.getAssetIssuer()),
                identityUtil.getIdentityFromPublicKey(transfer.getNewOwnerAndPossessor())
        );
        terminalWriter.writeAsync(message);
    }

}
