package at.qubic.shell.component.terminal;

import at.qubic.api.domain.std.SignedTransaction;
import at.qubic.shell.component.TransactionContext;
import at.qubic.shell.exception.PostProcessingException;
import reactor.core.publisher.Mono;

public interface TransactionTerminal<T extends TransactionContext> {

    TerminalWriter getTerminalWriter();
    void writeOperationDescription();
    void writeWaitForTickMessage(SignedTransaction signedTransaction);
    @SuppressWarnings("unused")
    Mono<?> writeTransactionProgress(int startTick, int targetTick, int currentTick);
    void writeSuccessMessage(T tc);
    void writeErrorMessage(PostProcessingException e);

}
