package at.qubic.shell.configuration;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.service.ComputorService;
import at.qubic.api.service.QearnTransactionService;
import at.qubic.api.service.TransactionService;
import at.qubic.shell.command.service.QearnService;
import at.qubic.shell.service.SendTransactionService;
import at.qubic.shell.component.QearnLockComponent;
import at.qubic.shell.service.KeyManagementService;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class QearnConfiguration {

    @Bean
    QearnTransactionService qearnTransactionService(TransactionService transactionService) {
        return new QearnTransactionService(transactionService);
    }

    @Bean
    QearnService qearnService(ComputorService computorService) {
        return new QearnService(computorService);
    }


    @Bean
    QearnLockComponent qearnLockComponent(KeyManagementService keyManagementService,
                                            QearnTransactionService qearnTransactionService,
                                            SendTransactionService sendTransactionService,
                                            IdentityUtil identityUtil) {
        return new QearnLockComponent(keyManagementService, qearnTransactionService, sendTransactionService, identityUtil);
    }
}
