package at.qubic.shell.configuration;

import at.qubic.api.crypto.IdentityUtil;
import at.qubic.api.service.ComputorService;
import at.qubic.api.service.QxTransactionService;
import at.qubic.shell.command.service.QxService;
import at.qubic.shell.service.SendTransactionService;
import at.qubic.shell.component.QxOrderComponent;
import at.qubic.shell.service.KeyManagementService;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class QxConfiguration {

    @Bean
    QxService qxService(ComputorService computorService) {
        return new QxService(computorService);
    }

    @Bean
    QxOrderComponent qxOrderComponent(KeyManagementService keyManagementService, QxTransactionService transactionService, SendTransactionService sendTransactionService, IdentityUtil identityUtil) {
        return new QxOrderComponent(keyManagementService, transactionService, sendTransactionService, identityUtil);
    }

}
