package at.qubic.shell.exception;

import lombok.Getter;

/**
 * Exception that might get thrown when trying to send and exception. It is thrown before sending, the transaction
 * never happened and can be repeated.
 */
public class SendTransactionException extends RuntimeException {

    @Getter
    protected boolean retryable = false; // default

    public SendTransactionException(String message) {
        super(message);
    }

    public SendTransactionException(String message, Throwable cause) {
        super(message, cause);
    }
}
