package at.qubic.shell.repository;

import lombok.extern.slf4j.Slf4j;
import at.qubic.shell.file.FileUtility;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

@Slf4j
public class WalletFileStore { // TODO rename to repository

    private final FileUtility fileUtility;
    private final String applicationDirectoryPath;
    private final String walletFile;

    public WalletFileStore(FileUtility fileUtility, String applicationDirectoryPath, String walletFile) {
        this.fileUtility = fileUtility;
        this.applicationDirectoryPath = applicationDirectoryPath;
        this.walletFile = walletFile;
    }

    public List<String> load() throws IOException {
        final Path path = Paths.get(applicationDirectoryPath, walletFile);
        log.info("Loading identities from [{}].", path);
        return fileUtility.load(path);
    }

    public void save(List<String> wallets) throws IOException {
        final Path path = Paths.get(applicationDirectoryPath, walletFile);
        log.info("Saving identities to [{}].", path);
        fileUtility.save(path, wallets);
    }

}
