package at.qubic.shell.service;

import at.qubic.shell.wallet.KeyManager;

public class KeyManagementService {

    private final KeyManager keyManager;

    public KeyManagementService(KeyManager keyManager) {
        this.keyManager = keyManager;
    }

    public boolean isLocked() {
        return keyManager.isLocked();
    }

    public boolean containsKey(String identity) {
        return keyManager.containsKeyAlias(identity);
    }

    public byte[] getPrivateKey(String identity) {
        return keyManager.getPrivateKey(identity);
    }

}
