package at.qubic.shell.command;

import org.junit.jupiter.api.Test;
import at.qubic.shell.command.service.EntityCommandService;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

class EntityCommandsTest {

    private final EntityCommandService entityCommandService = mock();
    private final EntityCommands command = new EntityCommands(entityCommandService);

    @Test
    void getEntity() {
        when(entityCommandService.getEntity("some-id")).thenReturn("foo");
        final String result = command.getEntity("some-id");
        assertThat(result).isEqualTo("foo");
    }

    @Test
    void getOwnedAssets() {
        when(entityCommandService.getOwnedAssets("some-id")).thenReturn("foo");
        final String result = command.getOwnedAssets("some-id");
        assertThat(result).isEqualTo("foo");
    }

    @Test
    void getPossessedAssets() {
        when(entityCommandService.getPossessedAssets("some-id")).thenReturn("foo");
        final String result = command.getPossessedAssets("some-id");
        assertThat(result).isEqualTo("foo");
    }

}