package at.qubic.shell.command;

import org.junit.jupiter.api.Test;
import at.qubic.shell.command.service.KeyService;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.*;

class LockKeyStoreCommandTest {

    private final KeyService keyManagementService = mock();
    private final LockKeyStoreCommand command = new LockKeyStoreCommand(keyManagementService);

    @Test
    void lock() {
        assertThat(command.lock()).containsIgnoringCase("Locked wallet");
        verify(keyManagementService).lock();
    }

    @Test
    void lock_givenAlreadyLocked_thenMessage() {
        when(keyManagementService.isLocked()).thenReturn(true);
        assertThat(command.lock()).isEqualTo("Wallet is already locked.");
        verify(keyManagementService, never()).lock();
    }

}