package at.qubic.shell.repository;

import org.junit.jupiter.api.Test;
import at.qubic.shell.file.FileUtility;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.Mockito.*;

class WalletFileStoreTest {

    private final FileUtility fileUtility = mock();
    private final WalletFileStore walletFileStore = new WalletFileStore(fileUtility, "dir", "file");

    @Test
    void load() throws IOException {
        when(fileUtility.load(any(Path.class))).thenReturn(List.of("a", "b", "c"));
        List<String> loaded = walletFileStore.load();
        assertThat(loaded).containsExactly("a", "b", "c");
    }

    @Test
    void save() throws IOException {
        List<String> wallets = List.of("a", "b", "c");
        walletFileStore.save(wallets);
        verify(fileUtility).save(Paths.get("dir", "file"), wallets);

    }

}