package at.qubic.shell.util;

import org.junit.jupiter.api.Test;

import java.nio.charset.StandardCharsets;

import static org.assertj.core.api.Assertions.assertThat;

class ConversionUtilTest {

    @Test
    void charsToBytes() {
        String test = "test";
        char[] testArr = test.toCharArray();
        byte[] testBytes = test.getBytes(StandardCharsets.UTF_8);

        assertThat(ConversionUtil.charsToBytes(testArr)).isEqualTo(testBytes);

        assertThat(testArr).isEqualTo("test".toCharArray()); // unchanged
        assertThat(testBytes).isEqualTo("test".getBytes(StandardCharsets.UTF_8)); // unchanged
    }

    @Test
    void bytesToChars() {
        String test = "test";
        char[] testArr = test.toCharArray();
        byte[] testBytes = test.getBytes(StandardCharsets.UTF_8);

        assertThat(ConversionUtil.bytesToChars(testBytes)).isEqualTo(testArr);

        assertThat(testArr).isEqualTo("test".toCharArray()); // unchanged
        assertThat(testBytes).isEqualTo("test".getBytes(StandardCharsets.UTF_8)); // unchanged

    }
}