package at.qubic.shell.wallet;

import at.qubic.shell.exception.UnknownAssetException;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.*;

class AssetsTest {

    private final Assets assets = new Assets();

    @Test
    void getAssetOrders_givenNoInferableIssuer_thenThrow() {
        assets.getAssets().add(Asset.builder().name("UNKNOWN").issuer("XYZ").build());
        assertThatThrownBy(() -> assets.getUniqueAssetForName("FOO"))
                .isInstanceOf(UnknownAssetException.class)
                .hasMessageContaining("No asset found for asset name [FOO]");
    }

    @Test
    void getAssetOrders_givenNoUniqueInferableIssuer_thenThrow() {
        assets.getAssets().add(Asset.builder().name("FOO").issuer("XYZ").build());
        assets.getAssets().add(Asset.builder().name("FOO").issuer("ABC").build());
        assertThatThrownBy(() -> assets.getUniqueAssetForName("FOO"))
                .isInstanceOf(UnknownAssetException.class)
                .hasMessageContaining("Multiple assets found for asset name [FOO]");
    }

}