package at.qubic.vanity.crypto;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.text.RandomStringGenerator;

public class StandardSeedGenerator implements SeedGenerator {

    private static final int SEED_LENGTH = 55;
    private int shift = Integer.MAX_VALUE;
    private String baseSeed = null;
    private final RandomStringGenerator randomStringGenerator;

    public StandardSeedGenerator(RandomStringGenerator randomStringGenerator) {
        this.randomStringGenerator = randomStringGenerator;
    }

    // careful not thread safe
    @Override
    public String seed() {
        if (shift < SEED_LENGTH-1) { // secure random is slow. rotate string.
            shift++;
            return StringUtils.rotate(baseSeed, shift);
        } else {
            baseSeed = randomStringGenerator.generate(SEED_LENGTH);
            shift = 0;
            return baseSeed;
        }
    }
}
