package at.qubic.vanity.crypto;

import org.junit.jupiter.api.Test;
import at.qubic.api.crypto.QubicFourQ;

import static org.assertj.core.api.Assertions.assertThat;

class IdentityUtilTest {

    private final IdentityUtil util = new IdentityUtil(new QubicFourQ());

    @Test
    void getIdentityFromPublicKey() {
        verifyId("sjklwvnfvsqrutwiixfjchqecqdnafujozygbzcctijynbytgrdihzq", "BLCFPJBEMLNXGDVJQOUVKCCHLPRCHQRRCMLBHECSEBGAMTHRTJTWLMUAKQPG");
        verifyId("abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabc", "CZPGJVFHPHHSIAMUOALHMCYFQYJCJGNPOYLLDYMKIGYYQEMJJNFMQCBFAVBB");
        verifyId("tcpykuzkmivjjsjqfcdnekqeggrooenxhwbfwgfigjkivbgthythbpk", "TESTHHKPOCSTJGBDJGUFHOKARUFAMUMGDFTQEVAHGHNABPPSENXMZTVDJRRA");
        verifyId("ewsvzoaeqhlxxoebzawvlvvsrgubvlyxvquucvdtjrekqxhmniuszqi", "TESTIOYEZSAUQBUNKJEGXOILIBICZYWAMVSWYCYFHDCSZOAXPTGSOKFCCUNK");
        verifyId("tnvquwhrpkrrxekrfivsxagmhqtrjrgbacdpkjfqegpbsvztuzyrier", "TESTJFDGICVGFHLRAZCKJKQYVEUBVYWTMRYYTPFXRESOQJGTKHCIHDJGFQZJ");
    }

    private void verifyId(String seed, String identity) {
        assertThat(util.identityFromSeed(seed)).isEqualTo(identity.getBytes());
    }

}