package at.qubic.vanity.crypto;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.text.RandomStringGenerator;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

class SeedFragmentGeneratorTest {

    public static final String SEED_FRAGMENT = "hello";
    private final RandomStringGenerator randomStringGenerator = mock();
    private final SeedFragmentGenerator seedGenerator = new SeedFragmentGenerator(SEED_FRAGMENT, randomStringGenerator);

    @Test
    void generate_thenStartWithFragment() {
        when(randomStringGenerator.generate(50)).thenReturn("foo");
        assertThat(seedGenerator.seed()).startsWith(SEED_FRAGMENT);
    }

    @Test
    void generate_thenRotateString() {
        String variablePart = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWX";
        when(randomStringGenerator.generate(50)).thenReturn(variablePart);
        for (int i = 0; i < 50; i++) {
            assertThat(seedGenerator.seed()).isEqualTo(SEED_FRAGMENT + StringUtils.rotate(variablePart, i));
        }
    }

}