package at.qubic.vanity.keygen;

import at.qubic.api.crypto.FourQ;
import at.qubic.vanity.crypto.RandomGeneratorFactory;
import at.qubic.vanity.crypto.SeedFragmentGenerator;
import at.qubic.vanity.crypto.SeedGenerator;

import java.util.function.Function;

public class IdFragmentGenerator extends VanityIdGenerator {

    private final String seedFragment;

    public IdFragmentGenerator(String seedFragment, RandomGeneratorFactory randomGeneratorFactory, FourQ fourQ) {
        super(randomGeneratorFactory, fourQ);
        this.seedFragment = seedFragment;
    }

    @Override
    protected Function<Long, SeedGenerator> createSeedGenerator() {
        return x -> new SeedFragmentGenerator(seedFragment, randomGeneratorFactory.create());
    }

}
